ThundergunWeaponBase = ThundergunWeaponBase or class(NewRaycastWeaponBase)
local mvec3_set = mvector3.set
local mvec3_add = mvector3.add
local mvec3_mul = mvector3.multiply
local mvec3_dis_sq = mvector3.distance_sq
local mvec3_lerp = mvector3.lerp
local mvec3_dir = mvector3.direction
local mvec3_cpy = mvector3.copy

function ThundergunWeaponBase:init(unit)
	ThundergunWeaponBase.super.init(self, unit)
end

local mvec_to = Vector3()
function ThundergunWeaponBase:_fire_raycast(user_unit, from_pos, direction, dmg_mul, shoot_player, spread_mul, autohit_mul, suppr_mul, shoot_through_data)
	local damage_range = 600
	local bullet_slotmask = managers.slot:get_mask("bullet_impact_targets_no_shields")
	local ignore_units = {}
	local flame_radius = 200
	
	mvec3_set(mvec_to, direction)
	mvec3_mul(mvec_to, damage_range)
	mvec3_add(mvec_to, from_pos)
	
	local col_ray = World:raycast("ray", from_pos, mvec_to, "slot_mask", bullet_slotmask, "ignore_unit", ignore_units)
	
	if col_ray then
		local col_dis = col_ray.distance

		if col_dis < damage_range then
			damage_range = col_dis or damage_range
		end

		mvec3_set(mvec_to, direction)
		mvec3_mul(mvec_to, damage_range)
		mvec3_add(mvec_to, from_pos)
	end
	
	local hit_bodies = World:find_bodies("intersect", "capsule", from_pos, mvec_to, flame_radius, bullet_slotmask)
	
	local weap_unit = self._unit
	local units_hit = {}
	local enemies_hit = {}
	local valid_hit_bodies = {}
	local player_unit = managers.player:player_unit()
	local in_slot_f = Unit.in_slot
	local damage = self:_get_current_damage(dmg_mul)
	local result = {}

	for i = 1, #hit_bodies do
		hit_body = hit_bodies[i]
		hit_unit = hit_body:unit()

		if not table.contains(ignore_units, hit_unit) then
			hit_u_key = hit_unit:key()

			if not units_hit[hit_u_key] then
				units_hit[hit_u_key] = true
				valid_hit_bodies[#valid_hit_bodies + 1] = hit_body

				if in_slot_f(hit_unit, enemy_mask) then
					enemies_hit[hit_u_key] = hit_unit
				end
			end
		end
	end

	local hit_count = 0
	local bullet_class = self:bullet_class()
	local hit_body, fake_ray_dir, fake_ray_dis = nil

	for i = 1, #valid_hit_bodies do
		hit_body = valid_hit_bodies[i]
		fake_ray_dir = hit_body:center_of_mass()
		fake_ray_dis = mvector3.direction(fake_ray_dir, from_pos, fake_ray_dir)
		local hit_pos = hit_body:position()
		local fake_ray = {
			body = hit_body,
			unit = hit_body:unit(),
			ray = fake_ray_dir,
			normal = fake_ray_dir,
			distance = fake_ray_dis,
			position = hit_pos,
			hit_position = hit_pos
		}

		if bullet_class:on_collision(fake_ray, weap_unit, user_unit, damage) then
			hit_count = hit_count + 1
		end
	end

	result.enemies_in_cone = self._suppression and self:check_suppression(from_pos, direction, enemies_hit) or nil
	
	return result
end

function ThundergunWeaponBase:clip_not_empty()
	return true
end
